﻿<%@ Control Language="C#" 
            AutoEventWireup="true" 
            CodeBehind="TimeSheetReport.ascx.cs" 
            Inherits="TimeTrakkerWeb.TimeSheetReport"             
%>
<!DOCTYPE html>
<html>
<head runat="server">
    <link href='~/App_Themes/Standard/Standard.css' 
          rel="stylesheet" type="text/css"  runat="server" />   
    <style type="text/css">
     html,body { height: 100%; }
     .itemcontainer
     {
     	margin: 5px;
     	padding: 5px;
     	border-bottom: dashed 1px teal;     	
     }
     .groupheader
     {
        font-size: 12pt;
     }
     .itemheader    
     {
     	font-size: 11pt;
     	font-weight: bold;
     	color: Navy;
     	margin-botton: 5px;
     }
     .itemheader a
     {
         text-decoration: none;
         color:Navy;
     }
    </style>
</head>
<body style="background: grey">

<div style="margin: 0 auto; left: 50px; text-align:left; background: white;width: 800px; border: solid 1px silver;padding: 30px;">

<div style="float: right;margin-right: 10px; margin-top: 10px; text-align:right;">
    From: <%= this.Parameters.FromDate.ToString("d") %><br />
    To: <%= this.Parameters.ToDate.ToString("d") %>
</div>
<div class="bigtext">
    <%= App.Configuration.CompanyName  %><br />
    <span style="font-size: 14pt; font-weight: normal;">Time Report</span>
</div>
<hr />

<asp:ListView runat="server" id="lstReport" ItemPlaceholderID="layoutContainer"  >
<LayoutTemplate>    
    <div id="layoutContainer" runat="server" />
</LayoutTemplate>
<ItemTemplate>    
    
    <%# this.RenderProjectGroupHeader(Container.DataItem as ReportEntryItem) %>
    <div class="itemcontainer">    
    <div class="itemheader"><a href='punchout.aspx?id=<%# Eval("Entry.Pk") %>'><%# Eval("Entry.Title") %></a></div>        
    <table style="width: 100%" cellpadding="5">
    <tr>
    <td style="width:140px;">
        <small><%# TimeUtils.ShortDateString((DateTime) Eval("Entry.TimeIn"),true) %><br />
        <%# TimeUtils.ShortDateString((DateTime) Eval("Entry.TimeOut"),true) %></small>
    </td>
    <td ><%# Eval("Entry.Description") %></td>
    <td style="width: 80px;text-align:right;font-weight: bold"><%# TimeUtils.FractionalHoursToString( (decimal) Eval("Entry.TotalHours"), "{0}h {1}min" ) %></td>
    </tr>
    </table>        
    </div>
    <%# this.RenderProjectFooter(Container) %>    
</ItemTemplate>
</asp:ListView>

<hr />
<%= App.Configuration.ReportFooter %>
</div>

</body>
</html>