﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Linq;
using System.Data.Common;
using System.Data;
using Westwind.Utilities.Data;

namespace Westwind.BusinessFramework.LinqToSql
{
    /// <summary>
    /// Customization of the LINQ to SQL DataContext class that provides
    /// core ADO.NET Data Access methods to the data context.
    /// </summary>
    public class DataContextSql : System.Data.Linq.DataContext
    {

        public DataAccessBase Db
        {
            get
            {
                if (_DbNative == null)
                    _DbNative = new SqlDataAccess(this.Connection.ConnectionString);
                return _DbNative;
            }
            set
            {
                _DbNative = value;
            }
        }
        private DataAccessBase _DbNative;


        
        static DataContextSql()
        {
        }

        //public DataContextSql(IDbNative native = new SqlNative())
        //{
        //    Db = native;
        //}

        public DataContextSql(string connection, System.Data.Linq.Mapping.MappingSource mappingSource) :
            base(connection, mappingSource)
        {
        }

        public DataContextSql(System.Data.IDbConnection connection, System.Data.Linq.Mapping.MappingSource mappingSource) :
            base(connection, mappingSource)
        {
        }
        

    }

}
