﻿<%@ Page Title="" Language="C#" MasterPageFile="~/WestWindWebToolkit.master" AutoEventWireup="true" CodeBehind="AutoComplete.aspx.cs" Inherits="Westwind.WebToolkit.Ajax.AutoComplete" %>
<%@ Register Assembly="CSharpFormat" Namespace="Manoli.Utils.CSharpFormat" TagPrefix="manoli" %>

<asp:Content ID="headers" ContentPlaceHolderID="Header" runat="server">    

    <style type="text/css">                   
        .contentcontainer
        {
            min-height: 150px;
            width: 570px;
            height: 620px;
            margin: 30px auto;
            padding-top: 0px;
        }        
        #divStockWrapper
        {
            border: solid 1px navy;
            background: cornsilk;
            display: none;    
            margin-top: 10px;
            padding: 10px;
            width: 550px;
        }
        #divStockDetail
        {
            margin: 10px 0px;
        }
        #divStockDetail td
        {    
            padding: 3px;
        }
        #divStockDetail td:first-child
        {
            text-align: right;
            font-weight: bold;
            width: 100px;
            padding-right: 15px;
        }
        #imgStockChart
        {
            display: none;    
            width: 450px;
        } 
        
        /* jQuery Ui AutoComplete specific overrides for rendering the drop down */
        .ui-autocomplete 
        {
		    max-height: 250px;
		    overflow-y: auto;
		    overflow-x: hidden;
		    padding-right: 20px;
		    width: 500px;
		    font-size: 1pt;
		    -moz-box-shadow: 3px 3px 5px #535353;
            -webkit-box-shadow: 3px 3px 5px #535353;       
            -box-shadow: 3px 3px 5px #535353;
	    }
	    .ui-corner-all
	    {
	        font-size: 0.90em;
	    }
        
</style>
</asp:Content>

<asp:Content ID="MainContent"  ContentPlaceHolderID="MainContent" runat="server">

    <h1>Using the jQuery AutoComplete Plugin</h1>
    
    <div class="toolbarcontainer">
        <div class="rightalign">
            <ww:HelpControl runat="server"  id="help" HelpTopic="_3bq135bj8.htm"  Text="Docs"  CssClass="hoverbutton"/>
        </div>
        <a href="./" class="hoverbutton"><asp:Image ID="Image1" runat="server" ImageUrl="~/css/images/Home.gif"  AlternateText="Home" /> Home</a> | 
        <asp:LinkButton runat="server" ID="lnkRefresh" class="hoverbutton"><asp:Image ID="Image2" runat="server" ImageUrl="~/css/images/Refresh.gif"  AlternateText="Reset Page"/> Reset Page</asp:LinkButton> |         
        <small>Page created: <%= DateTime.Now.ToString() %></small><br />
    </div>
    
    <div class="descriptionheader">
        This example uses the AutoComplete Web Forms control which is a wrapper around the jQuery.Ui AutoComplete
        component. This plug-in provides an easy way to drop the control onto the page and get the appropriate resources
        loaded and have an easy way to specify common load properties and easily return the data needed to feed
        the auto-complete list drop down, either from an external URL or through an event handled in the 
        current page.
    </div>            
    
    <div class="contentcontainer"  runat="server" id="PageContent">
        <h2>Stock Quote Lookup</h2>
        
        <div class="labelheader" style="margin-top: 20px;">Enter a stock symbol:</div>

        <%--This one fires an external Url--%>
        <ww:AutoComplete runat="server" ID="txtSymbol" 
                            style="width: 75px;"  
                            ServerUrl="AutoCompleteHandler.ashx?Method=GetStockLookup"                               
        />                

        <input type="button" id="btnGetQuote" value="Get Quote (Handler)"  />

        <hr />

        <%--This one calls back to the current page and fires an event--%>
        <ww:AutoComplete runat="server" ID="txtSymbol2" 
                            style="width: 75px;"                                                          
                            OnClientSelection="onAutoCompleteSelection"                      
        />
        <input type="button" id="btnGetQuote2" value="Get Quote (Page Event)"  />
        <div id="divCompany" class="smalltext"></div>
        
        <br />          
        
        <div id="divStockWrapper">
            <div id="divStockDetail">        
            </div>
            <img id="imgStockChart"  />
        </div>
    </div>
    
    <ww:AjaxMethodCallback runat="server" ID="Proxy" ServerUrl="AutoCompleteHandler.ashx" />
    
    
    <script type="text/javascript">
        $(document).ready(function () {
            // set up AutoComplete plugin
            var txtSymbol = $$("txtSymbol");

            // hook up event handlers for page
            $("#btnGetQuote,#btnGetQuote2").click(GetStockQuote);

            // set error display on 'status bar'
            showStatus({ afterTimeoutText: "Ready" });

            // load up stock quote immediately when page loads
            // if value is set
            if (txtSymbol.val())
                GetStockQuote();

        });

        // you can create custom handlers
        function onAutoCompleteSelection(item, ui) {
            
            $$("txtSymbol2").val(ui.item.value);
            var elCo = $("#divCompany").text(ui.item.company);
            
            // return false to override default value assignment
            return false;
        }

        function GetStockQuote() {
            var symbol = $$("txtSymbol").val();            
            if (this.id == "btnGetQuote2")
                symbol = $$("txtSymbol2").val();

            if (!symbol) {
                showStatus("Please enter a symbol to lookup.", 5000, true);
                return;
            }            
            $("#divStockWrapper").fadeTo(200, .11);

            // get the stock data to display and expand from template
            Proxy.GetStockQuote(symbol,
                    function(quote) {
                        // update the image
                        $("#imgStockChart")
                            .attr("src", "AutoCompleteHandler.ashx?method=GetStockHistoryGraph&symbol=" + symbol)
                            .show();

                        if (quote == null) {
                            showStatus("Invalid ticker symbol.", 5000, true);
                            $("#divStockWrapper").hide();
                            return;
                        }

                        // use client template to render the stock display
                        var stockTemplate = $("#StockItemTemplate").html();
                        var html = parseTemplate(stockTemplate, quote);

                        $("#divStockDetail")
                            .html(html);

                        $("#divStockWrapper").show().stop().fadeTo(1000, 1);

                    }, onPageError);                                        
        }


    </script>

    <script id="StockItemTemplate" type="text/html">
        <table id="tblStockDetail">
            <tr>
                <td>Company:</td>
                <td><#= Company #></td>
            </tr>
            <tr>
                <td>Last Price:</td>
                <td><#= LastPrice.formatNumber("n2") #> &nbsp; &nbsp; <b> <#= NetChange < 0 ? "<span style='color:red'> " + NetChange.formatNumber("n2") + "</span>" : "<span style='color: green'>+  " + NetChange.formatNumber("n2") + "</span>" #></b></td>
            </tr>
            <tr>
                <td>
                  Open Price:
                </td>
                <td>
                    <#= OpenPrice.formatNumber("n2")  #>  
                </td>
            </tr>
            <tr>
                <td>Quote Date:</td>
                <td><#= LastQuoteTime.formatDate("MMM dd, HH:mm ") #></td>
            </tr>
        </table>        
    </script>
   

    <div class="toolbarcontainer">
        <manoli:viewsourcecontrol id="ViewSourceControl" runat="server" text="Show ASPX"
            displaystate="Button" codefile="AutoComplete.aspx" />
        <manoli:viewsourcecontrol id="ViewSourceControl1" runat="server" text="Show CodeBehind"
            displaystate="Button" codefile="AutoComplete.aspx.cs" />
        <manoli:viewsourcecontrol id="ViewSourceControl2" runat="server" text="Show AutoComplete Handler"
            displaystate="Button" codefile="AutoCompleteHandler.ashx.cs" />
    </div>    
    
    <ww:ScriptContainer ID="scripts" runat="server" RenderMode="Header">
        <Scripts>
            <script src="../Scripts/jquery.js" resource="jquery"></script>
            <script src="../Scripts/jquery-ui.js" resource="jqueryui"></script>
            <script src="../Scripts/ww.jquery.js" resource="ww.jquery"></script>
            <%--<script src="../scripts/ThirdParty/jquery.autocomplete.js" allowminscript="true"></script>  --%>          
        </Scripts>
    </ww:ScriptContainer>
    
</asp:Content>
