﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Westwind.Web;
using System.IO;
using System.Text;

namespace Westwind.WebToolkit.Ajax
{
    public partial class AutoComplete : System.Web.UI.Page
    {

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);

            // Applied against the second AutoComplete Control only
            // using an event handler to return the result            
            txtSymbol2.CallbackHandler += AutoCompleteDataHandler;
        }

        object AutoCompleteDataHandler(string term)
        {
            // From Autocomplete plug-in
            string partial = term;
            //Request.QueryString["term"] as string;

            int maxItems = 50;

            busPortfolioItem stocks = new busPortfolioItem();

            // filter symbols to search term - note that you must returns label/value, but you can
            // add additional properties which are accessible in the item on the client
            var symbolList = stocks.GetSymbolList(partial)
                                    .Select(stock => new
                                    {
                                        label = stock.Symbol + " -  " + stock.Company,
                                        value = stock.Symbol,
                                        company = stock.Company
                                    })
                                    .Take(maxItems);

            return symbolList.ToArray();
        }


        protected void Page_Load(object sender, EventArgs e)
        {

            // Provide client proxy type so we can get a client wrapper for service methods
            Proxy.ClientProxyTargetType = typeof(AutoCompleteHandler);

            if (!this.IsPostBack)
                this.txtSymbol.Text = Request.QueryString["symbol"];

        }
    }
}
