<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="TabClientControl.aspx.cs"
    Inherits="Westwind.WebToolkit.Controls.TabClientControl" MasterPageFile="~/WestWindWebToolkit.master" %>

<asp:Content ID="headers" ContentPlaceHolderID="Header" runat="server">
    <script type="text/javascript" src="../scripts/jquery.js"></script>
    <style>
        .tabs, .tabs > li
        {
            list-style: none;
            margin-left: 0px;
            display: block;
        }
        .tabs
        {
            clear: both;
        }
        
        .tbutton, .tbutton-selected
        {
            float: left;
            background: #D3D3D3;
            color: Black;
            border-radius: 6px 6px 0 0;
            min-width: 100px;
            padding: 6px;
            border: solid 1px #535353;
            margin-right: 3px;
            box-shadow: 2px 0px 3px #535353;
        }
        .tbutton-selected
        {
            font-weight: bold;
            background: #4062A7;
            color: White;
        }
        .tbutton:hover
        {
            background: #4682B4;
            color: White;
            font-weight: normal;
        }
        .tbutton a, .tbutton-selected a
        {
            text-decoration: none;
            color: inherit;
        }
.code
{
	font-family: monospace,courier new;
	font-weight: bold;
	font-size: 1em;
	background: whitesmoke;
	color: darkblue;
}
.codeexample
{
    border: solid 1px steelblue;
    border-radius: 4px 4px 4px 4px;    
    margin: 0 5px 5px 0px;	 
    padding: 10px;
    box-shadow: 2px 2px 4px #535353;   
}
.codeexampleheader
{
	font-weight: bold;
        font-size: 12pt;
        color: navy;
}
    </style>
</asp:Content>
<asp:Content ID="content" ContentPlaceHolderID="MainContent" runat="server">
    <h1>
        Client TabControl</h1>
    <div class="descriptionheader">
        The TabControl class provides a very simple, client side handled tab manager that
        is managed through an ASP.NET server control. The control uses client script code
        to activate/deactivate HTML elements on the page by mapping tabs to HTML elements
        which are hidden or displayed. No dependencies on any external libraries.
    </div>
    <div class="toolbarcontainer">
        <a href="../" class="hoverbutton">Home</a> | <a href="TabClientControl.aspx" class="hoverbutton">
            Reload</a> |
        <ww:HelpControl ID="HelpControl" runat="server" HelpTopic="_2te177hra.htm" CssClass="hoverbutton" />
    </div>
    <div class="containercontent">

    <div id="tabcontainer" class="tbutton">tab1</div>
    <div id="tabcontainer2" class="tbutton">tab2</div>
    <br clear="both" />


    <div class="codeexample">
        <pre>
        Here's some code
        </pre>
    </div>

    <hr />


        <h3 class="outdent" id="example">Example</h3>
<pre></pre><div class="codeexample"><div class="codeexampleheader">c#</div><pre><div class="csharpcode"><span class="datatypes">int</span> x = 0;
x++;</div></pre></div>

<div class="codeexample"><div class="codeexampleheader">vb.net</div><pre><div class="vbcode"><span class="statements">dim</span> x <span class="keywords">as</span> <span class="datatypes">integer</span>
x = 1;
x = x + 1;</div></pre></div><pre></pre>


    </div>
    <script type="text/javascript">
        $(document).ready(function () {
            //var tabs = new Tabs();
            ///tabs.add("#page1").add("#page2").add("#page3");            

            //$("#example").codeExampleTabs();
        });



        $.fn.codeExampleTabs = function (options) {

            opt = { tabClass: "tbutton",
                tabSelectedClass: "tbutton-selected",
                onClick: null
            };
            $.extend(opt, options);
            $orig = this;

            if (this.length == 0)
                return this;

            var $theader = $("<div id='" + this.get(0).id + "_codetabs'>");
            $(".codeexample:first").before($theader);

            var tabcontainers = $(".codeexample");

            tabcontainers.each(function (i) {
                var $el = $(this);
                var $header = $(this).find(".codeexampleheader");
                var lang = $header.text();

                var x = $("<div>").addClass(opt.tabClass)
                                  .text(lang)
                                  .click(function () {   
                                      if ($(this).hasClass(opt.tabSelectedClass) )                                 
                                         return;

                                      $orig.find("~.codeexample").hide();
                                      $theader.find("." + opt.tabSelectedClass).removeClass(opt.tabSelectedClass).addClass(opt.tabClass);
                                      $(this).addClass(opt.tabSelectedClass).removeClass(opt.tabClass);
                                      $el.show();
                                  });
                if (i == 0) {
                    $el.show();
                    x.addClass(opt.tabSelectedClass).removeClass(opt.tabClass);
                }
                else {
                    $el.hide();
                    x.removeClass(opt.tabSelectedClass);
                }

                $header.remove();

                $theader.append(x);
            });

            $theader.after("<div style='clear: both'>");
            return this;
        };

//    $.fn.tabs = function() {
//       var tabs = { 
//            headers:null,
//            tabs: []
//       };

//       //$("div").attr("id",

//       this.find(">li>a").each(function() {          
//          tabs.tabs.push( $(   $(this).attr("href") ) );
//       });
//       
//       
//       
//       
//       this.remove();
//    });
    
    //$(".tabs").tabs( function() {


    this.Tabs = function () {
        _I = this;

        this.tabs = [];
        this.$tab = null;
        this.onActivate = null;

        this.addTab = function(el) {
            tabs.push($(el));
            return _I;    
        },
        this.activateTab= function(num) {
            
            if (_I.onActivate && _I.onActivate(num))
                return;

            if (typeof (num) == 'string') {
                for (var x = 0; x < _I.tabs.length; x++) {
                    if (_I.tabs[x].pageId == num)
                    { num = x; break; }
                }
            }
            if (typeof (num) == 'string') num = 0;

            var tab = _I.tabs[num];
            for (var i = 0; i < I_.tabs.length; i++) {
                var t = _tabs[i];
                
                document.getElementById(t.tabId).className = (t.enabled ? 'tabbutton' : 'disabledtabbutton');
                if (t.pageId)
                    document.getElementById(t.pageId).style.display = 'none';
            }
            document.getElementById(Tab.tabId).className = 'selectedtabbutton';
            document.getElementById(Tab.pageId).style.display = '';
            document.getElementById('__TABSELECTION_ctl00_MainContent_TabControls').value = Tab.pageId;
        }        
    };
    
    window.onresize
    </script>

    <td class="sidebar" style="width: 245px;border-collapse: collapse">
</asp:Content>
