﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="Westwind.WebToolkit.Rest.Default" %>
<%@ Register Assembly="CSharpFormat" Namespace="Manoli.Utils.CSharpFormat" TagPrefix="manoli" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Rest Examples</title>
    <link href="../css/Westwind.css" rel="stylesheet" type="text/css" />
    <link href="../Css/WebToolkitSamples.css" rel="stylesheet" type="text/css" />
    <script src="../scripts/jquery.min.js" type="text/javascript"></script>
    <script src="../scripts/ww.jquery.min.js" type="text/javascript"></script>
</head>
<body>
    <form id="form1" runat="server">
    <div>

    <h1>REST Service Examples</h1>
    <div class="toolbarcontainer">
        <a href="../" class="hoverbutton"><img src="../css/images/home.gif" /> Home</a> |
    </div>
    <div class="descriptionheader">
        These examples demonstrate a simple REST service that can be invoked directly via URL. The examples
        below output JSON and XML. Note that for most browsers JSON content will download rather than display
        in the browser.
        If you're running FireFox I recommend you install the <a href="https://addons.mozilla.org/en-US/firefox/addon/jsonview/">JsonView plug-in</a>
        to directly view JSON content in FireFox. For IE you can <a href="http://adallow.wordpress.com/2008/10/13/viewing-applicationjson-mime-type-docs-in-your-browser/">
        hack the registry</a> to display JSON as text in the browser.
    </div>

    <div class="containercontent">
        
        <ul>
            <li><b>Retrieve a single Stock Quote as Rest Data</b><br />
                <div style="margin-left: 20px;margin-bottom: 10px;">
                <strong>Raw Urls:</strong><br />
                <a href='<%= ResolveUrl("~/Rest/StockService.ashx?method=GetStockQuote&symbol=msft") %>'><%= WebUtils.ResolveServerUrl("~/Rest/StockService.ashx?method=GetStockQuote&symbol=msft")%></a><br />
                <a href='<%= ResolveUrl("~/Rest/StockService.ashx?method=GetStockQuote&symbol=gld&format=xml") %>'><%= WebUtils.ResolveServerUrl("~/Rest/StockService.ashx?method=GetStockQuote&symbol=gld&format=xml")%></a><br />

                <strong>Clean Routed Urls:</strong><br />
                <a href='<%= ResolveUrl("~/stockquote/intc") %>'><%= WebUtils.ResolveServerUrl("~/stockquote/intc") %></a><br />
                <a href='<%= ResolveUrl("~/stockquote/slw?format=xml") %>'><%= WebUtils.ResolveServerUrl("~/stockquote/slw?format=xml") %></a><br />                
                </div>
            </li>
        
            <li><b>Retrieve a set of Stock Quotes as Rest Data</b><br />
                <div style="margin-left: 20px;margin-bottom: 10px">
                    <b>Raw Urls:</b><br />                        
                    <a href='<%= ResolveUrl("~/Rest/StockService.ashx?Method=GetStockQuotes&symbolList=msft,intc,gld,slw,mwe") %>'><%= WebUtils.ResolveServerUrl("~/Rest/StockService.ashx?Method=GetStockQuotes?symbolList=msft,intc,gld,slw,mwe")%></a><br />
                    <a href='<%= ResolveUrl("~/Rest/StockService.ashx?Method=GetStockQuotes&symbolList=msft,intc,gld,slw,mwe&format=xml") %>'><%= WebUtils.ResolveServerUrl("~/Rest/StockService.ashx?Method=GetStockQuotes?symbolList=msft,intc,gld,slw,mwe&format=xml")%></a><br />

                    <b>Clean Routed Urls:</b><br />
                    <a href='<%= ResolveUrl("~/stockquotes/msft,intc,gld,slw,mwe") %>'><%= WebUtils.ResolveServerUrl("~/stockquotes/msft,intc,gld,slw,mwe")%></a><br />
                    <a href='<%= ResolveUrl("~/stockquotes/msft,intc,gld,slw,mwe?format=xml") %>'><%= WebUtils.ResolveServerUrl("~/stockquotes/msft,intc,gld,slw,mwe?format=xml")%></a><br />
                </div>
            </li>

            <li><b>Retrieve Stock History as a an graphic Chart</b>
                <div style="margin-left: 20px;margin-bottom: 10px">
                    <b>Raw Urls:</b><br />                        
                    <a href='<%= ResolveUrl("~/Rest/StockService.ashx?Method=GetStockHistoryGraph&symbolList=msft,intc,gld,slw,mwe") %>'><%= WebUtils.ResolveServerUrl("~/Rest/StockService.ashx?Method=GetStockHistoryGraph&symbolList=msft,intc,gld,slw,mwe")%></a><br />
                    <b>Clean Routed Urls:</b><br />
                    <a href='<%= ResolveUrl("~/stockhistory/msft,intc,gld,slw,mwe") %>'><%= WebUtils.ResolveServerUrl("~/stockhistor/msft,intc,gld,slw,mwe")%></a><br />
                </div>
            
            </li>
        </ul>
    

        <div class="toolbarcontainer">
            <manoli:viewsourcecontrol id="ViewSourceControl3" runat="server" text="Show Callback Service Handler"
                                      displaystate="Button" CodeFile="~/Rest/StockService.ashx.cs"                                       
                                      />            
        </div>
            
    </div>
    
    </div>

       
    </form>
</body>
</html>
