﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Westwind.BusinessFramework.EfCodeFirst;

namespace Westwind.WebToolkit
{
    public class busAlbum : EfCodeFirstBusinessBase<Album,AlbumContext>
    {

        public IQueryable<Album> GetAlbumsByArtist(string artistName)
        {
            return Context.Albums.Where(albm => albm.Artist.ArtistName == artistName).OrderBy( albm => albm.AlbumName);
        }

        public IQueryable<Album> GetAllAlbums()
        {            
            return Context.Albums.OrderBy(alb => alb.Artist.ArtistName +  alb.AlbumName);       
        }

        public Album LoadAlbum(int id)
        {
            Album album = Context.Albums.Where(alb => alb.Id == id).FirstOrDefault();
            return album;
        }


        public Album NewEntity(string albumName, string artistName)
        {
            // Call base new Entity to create a new Album entity
            var album = base.NewEntity();

            if (album == null)
                return null;

            album.AlbumName = albumName;

            // Check if artist exists already
            var artist = Context.Artists.Where(art => art.ArtistName == artistName).FirstOrDefault();
            if (artist == null)
                // nope create a new one
                artist = new Artist() { ArtistName = artistName } ;
            
            album.Artist = artist;

            return album;
        }

        public void AddSong(string songName, string songPublisher = null, string songLength = null, Album album = null)
        {
            if (album == null)
                album = this.Entity;

            album.Songs.Add(new Song() { SongName = songName, Composer = songPublisher, SongLength = songLength });
        }

    }
}